Bug 1127894 - Review Request: jsap
Summary: Review Request: jsap
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: gil cattaneo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1130755 1130756
Blocks: 919550
TreeView+ depends on / blocked
 
Reported: 2014-08-07 18:54 UTC by Ismael Olea
Modified: 2014-08-21 16:09 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-08-21 16:09:52 UTC
puntogil: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Ismael Olea 2014-08-07 18:54:58 UTC
http://olea.org/tmp/jsap.spec
http://copr-be.cloud.fedoraproject.org/results/olea/OmegaT/fedora-rawhide-x86_64/jsap-2.1-5.1.olea/jsap-2.1-5.1.fc22.src.rpm
https://copr.fedoraproject.org/coprs/olea/OmegaT/build/24903/

Description :
JSAP not only syntactically validates your program's command line
arguments, but it converts those arguments into objects you specify. If you
tell JSAP that one of your parameters is an Integer, for example, and the
user does not provide a String that can be converted to an Integer when
invoking the program, JSAP will throw a ParseException when you have it
parse the command line. If no exception is thrown, you are guaranteed an
Integer when you request that parameter's value from your program. There's
a pretty big (and growing) list of return types suppored by JSAP, including
Integers, Floats, Dates, URLs, an

Applied: https://fedoraproject.org/wiki/Packaging:JPackagePolicy?rd=Packaging/JPackagePolicy

Comment 2 gil cattaneo 2014-08-18 09:26:39 UTC
please,remove 
#%pom_add_dep com.martiansoftware.snip %{name}.pom
#%pom_add_dep com.martiansoftware.rundoc %{name}.pom
or create some template pom for both packages
e.g.


<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>com.martiansoftware.@PROJECT@</groupId>
    <artifactId>@PROJECT@</artifactId>
    <version>@VERSION@</version>
    <packaging>jar</packaging>
</project>

there are unneeded BR:
BuildRequires:  java-devel >= 1:1.6.0
BuildRequires:  maven-local
you can use only
BuildRequires:  javapackages-tools
or better
BuildRequires:  javapackages-local

unnecessary Requires (XMvn handled by XMvn - javapackages-*)
Requires:       java-headless >= 1:1.6.0
Requires:       javapackages-tools
also for sub package javadoc
Requires:       %{name} = %{version}-%{release}
Requires:       javapackages-tools

this should be a bug in XMvn, please contact mizdebsk@redhat.com for more info
%dir /usr/share/maven-poms/%{name}/

please fix unowner %dir /usr/share/java/%{name}/

please use %dir %{_javadir}/%{name}/ instead of %dir /usr/share/java/%{name}/

"Group:" tag is no longer necessary.

please, cleanup spec file:
remove %define * (unused)


use:
find . -name "*.jar" -delete
find . -name "*.class" -delete


You can make maven install the javadocs by passing -J to mvn_install
%mvn_install -J javadoc
And then in the files section, you can have:
%files javadoc -f .mfiles-javadoc

Comment 3 gil cattaneo 2014-08-18 09:29:51 UTC
for remove some rpmlint warning exclude jpp comment in changelog

Comment 4 gil cattaneo 2014-08-18 12:36:49 UTC
(In reply to gil cattaneo from comment #2)
> please,remove 
> #%pom_add_dep com.martiansoftware.snip %{name}.pom
> #%pom_add_dep com.martiansoftware.rundoc %{name}.pom

not have sense add these libraries as build deps.

the only dependencies required by jsap should be ant and xstream

<pathelement location="${lib}/ant.jar"/>
<pathelement location="${lib}/junit.jar"/> used only for testing?
<pathelement location="${lib}/xstream-1.1.2.jar"/>


javac target andsource MUST be changed in 1.5 or major (in ant build script/s)

Comment 5 Ismael Olea 2014-08-20 19:51:46 UTC
(In reply to gil cattaneo from comment #4)
> (In reply to gil cattaneo from comment #2)
> > please,remove 
> > #%pom_add_dep com.martiansoftware.snip %{name}.pom
> > #%pom_add_dep com.martiansoftware.rundoc %{name}.pom
> not have sense add these libraries as build deps.

I'll remove this pom references but snip and rundoc are required for building the documentation (manual ant task)

> javac target andsource MUST be changed in 1.5 or major (in ant build
> script/s)

Ok

(In reply to gil cattaneo from comment #2)
> please,remove 
> #%pom_add_dep com.martiansoftware.snip %{name}.pom
> #%pom_add_dep com.martiansoftware.rundoc %{name}.pom

done

> there are unneeded BR:

done

> unnecessary Requires (XMvn handled by XMvn - javapackages-*)
> [...]
done

> use:
> find . -name "*.jar" -delete
> find . -name "*.class" -delete

I choose to explicit remove existing files in order to easy detect changes in future releases.

Here is the last revision:

http://olea.org/tmp/jsap-2.1-5.3.fc22.src.rpm
http://olea.org/tmp/jsap.spec

Comment 6 gil cattaneo 2014-08-20 20:42:35 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 94 files have unknown license. Detailed output of
     licensecheck in /home/gil/1127894-jsap/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[?]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/maven-metadata
[?]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/maven-metadata
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.

Requires:       javapackages-tools should be removed

[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in jsap-
     javadoc , jsap-doc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
IGNORE Not relevant

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: jsap-2.1-5.3.fc22.noarch.rpm
          jsap-javadoc-2.1-5.3.fc22.noarch.rpm
          jsap-doc-2.1-5.3.fc22.noarch.rpm
          jsap-2.1-5.3.fc22.src.rpm
jsap.noarch: W: spelling-error %description -l en_US awt -> aw, at, wt
jsap.src: W: spelling-error %description -l en_US awt -> aw, at, wt
jsap.src: E: specfile-error /usr/bin/build-classpath: error: Could not find snip Java extension for this JVM
jsap.src: E: specfile-error /usr/bin/build-classpath: error: Could not find rundoc Java extension for this JVM
jsap.src: E: specfile-error /usr/bin/build-classpath: error: Some specified jars were not found
jsap.src: E: specfile-error mvn_install: invalid option -- 'J'
jsap.src: E: specfile-error error: Unknown option J in mvn_install()
4 packages and 0 specfiles checked; 5 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint jsap-doc jsap jsap-javadoc
jsap.noarch: W: spelling-error %description -l en_US awt -> aw, at, wt
3 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/gil/1127894-jsap/srpm/jsap.spec	2014-08-20 22:16:09.019199939 +0200
+++ /home/gil/1127894-jsap/srpm-unpacked/jsap.spec	2014-08-20 20:55:56.000000000 +0200
@@ -89,5 +89,5 @@
 %patch1 
 
-cp %{SOURCE1} %{name}.pom
+cp  %{SOURCE1}  %{name}.pom
 
 %build
@@ -108,5 +108,4 @@
 %mvn_install -J javadoc/
 
-
 %files -f .mfiles
 %doc LICENSE.TXT CHANGELOG.TXT


Requires
--------
jsap-doc (rpmlib, GLIBC filtered):

jsap (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    jpackage-utils

jsap-javadoc (rpmlib, GLIBC filtered):
    jpackage-utils



Provides
--------
jsap-doc:
    jsap-doc

jsap:
    jsap
    mvn(com.martiansoftware:jsap)
    mvn(com.martiansoftware:jsap:pom:)

jsap-javadoc:
    jsap-javadoc



Source checksums
----------------
http://prdownloads.sourceforge.net/jsap/JSAP-2.1-src.tar.gz :
  CHECKSUM(SHA256) this package     : 5146bf75cba18fdf9299462a4127e95919c884494aaf3ed023cb2950217a0862
  CHECKSUM(SHA256) upstream package : 5146bf75cba18fdf9299462a4127e95919c884494aaf3ed023cb2950217a0862
http://central.maven.org/maven2/com/martiansoftware/jsap/2.1/jsap-2.1.pom :
  CHECKSUM(SHA256) this package     : 9acf56a8579c05bedd819d99232363e2bf327e8f73c67598dbd9885a845a3c69
  CHECKSUM(SHA256) upstream package : 9acf56a8579c05bedd819d99232363e2bf327e8f73c67598dbd9885a845a3c69


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -b 1127894 --plugins Java -m fedora-rawhide-i386 -L /home/gil/deps
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Built with local dependencies:
    /home/gil/deps/rundoc-0.11-3.fc22.noarch.rpm
    /home/gil/deps/snip-0.11-3.fc22.noarch.rpm

Comment 7 gil cattaneo 2014-08-20 20:47:17 UTC
Spec file history should be not interesting, exclude jpp comment in changelog

[?]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/share/maven-metadata
[?]: Requires correct, justified where necessary.
Requires:       javapackages-tools should be removed

[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
IGNORE Not relevant

Set free to resolve these problems @ import time

Approved

Comment 8 Ismael Olea 2014-08-20 21:22:40 UTC
New Package SCM Request
=======================
Package Name:  jsap
Short Description: A Java-based Simple Argument Parser
Upstream URL: http://www.martiansoftware.com/jsap/
Owners: olea
Branches: f21

Comment 9 Gwyn Ciesla 2014-08-21 11:57:39 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.